local context = UI.CreateContext("HUD")
local enabled = False
local topc = 1 -- Track Only Player Casts
local trackedBuffs = {}
local alertedSoon = {}
local alertedDown = {}
local abilityList = {}
local abilityDeets = {}
local listToTrack = {}
local possibleToTrack = {}
local notificationDown --frame for notifications of buffs that are currently down
local notificationSoon -- frame for notifications of buffs that will soon be down
local downAnnounce = " "
local soonAnnounce = " "

print("Bard Buffs v 0.1 by Crimius, /bb for help")

notificationDown = UI.CreateFrame("Frame", "DownAnnouncements", context)
notificationDown:SetPoint("TOP", UIParent, "TOP")
notificationDown.text = UI.CreateFrame("Text", "Text", notificationDown)
notificationDown.text:SetFontSize(20)
notificationDown.text:SetText(downAnnounce)
notificationDown.text:SetPoint("TOPCENTER", UIParent, "TOPCENTER")
notificationDown.text:SetHeight(0)
notificationDown.text:SetWidth(0)
notificationDown:SetVisible(false)

notificationSoon = UI.CreateFrame("Frame", "SoonAnnouncements", context)
notificationSoon:SetPoint("TOPCENTER", notificationDown, "BOTTOMCENTER")
notificationSoon.text = UI.CreateFrame("Text", "Text", notificationSoon)
notificationSoon.text:SetFontSize(20)
notificationSoon.text:SetText(soonAnnounce)
notificationSoon.text:SetPoint("TOPCENTER", notificationDown.text, "BOTTOMCENTER")
notificationSoon.text:SetHeight(0)
notificationSoon.text:SetWidth(0)
notificationSoon:SetVisible(false)


--Alerts.
---------------------------------------------------

local function alertDown(buff, key)
	local tmp = alertedDown
	local newDowns = " "
	for k,v in pairs(tmp) do
		if v.begin <= (Inspect.Time.Frame() - v.duration - 5) then
			alertedDown[k] = nil
		end
	end
	--downAnnounce = " "
	for k,v in pairs(alertedDown) do
		newDowns = newDowns .. v.name .. " is Down! Recast!\n "
	end
	if downAnnounce ~= newDowns then
		downAnnounce = newDowns
		notificationDown.text:SetText(downAnnounce)
		if downAnnounce ~= " " then
			notificationDown.text:SetHeight(notificationDown.text:GetFullHeight())
			notificationDown.text:SetWidth(notificationDown.text:GetFullWidth())
			notificationDown:SetVisible(true)
		else
			notificationDown.text:SetHeight(0)
			notificationDown.text:SetWidth(0)
			notificationDown:SetVisible(false)
		end
	end
	
	if buff then
		if buff.duration then
			if buff.begin <= (Inspect.Time.Frame() - buff.duration)  then
				trackedBuffs[key] = nil
				if alertedDown then
					tmp = alertedDown
					local flag = 0
					for k,v in pairs(tmp) do
						if v.name == buff.name then
							if v.begin == buff.begin then
								flag = 1
							else
								alertedDown[k] = nil
							end
						end
						if v.duration then
							if v.begin <= (Inspect.Time.Frame() - v.duration - 5) then
								alertedDown[k] = nil
							end
						end
					end			
					if flag == 0 then
						table.insert(alertedDown, buff)
					end
				end
			end
		end
	end
end

local function alertSoon(buff)
	local tmp = alertedSoon
	local newSoons = " "
	for k,v in pairs(tmp) do
		if v.begin <= (Inspect.Time.Frame() - v.duration) then
			alertedSoon[k] = nil
		end
	end
	
	for k,v in pairs(alertedSoon) do
		newSoons = newSoons .. v.name .. " is going down soon!\n "
	end
	if soonAnnounce ~= newSoons then
		soonAnnounce = newSoons
		notificationSoon.text:SetText(soonAnnounce)
		if soonAnnounce ~= " " then
			notificationSoon.text:SetWidth(notificationSoon.text:GetFullWidth())
			notificationSoon.text:SetHeight(notificationSoon.text:GetFullHeight())
			notificationSoon:SetVisible(true)
		else
			notificationSoon.text:SetHeight(0)
			notificationSoon.text:SetWidth(0)
			notificationSoon:SetVisible(false)
		end
	end
	
	if buff then
		if buff.duration then
			if buff.begin <= (Inspect.Time.Frame() - buff.duration)  then
			elseif buff.remaining <= 5 then

				-- Here we are alerting that a buff will be dropping soon.  First we check out our table of buffs we've already alerted for, alertedSoon, for the buff we were just given.
				-- If we do find it, then we check it's start time against our new buffs start time.  if they don't line up, we know we have a new buff and we should alert it and update our alertedSoon entry.
				local flag = 0
				if alertedSoon then
					tmp = alertedSoon
					for k,v in pairs(tmp) do
						if v.name == buff.name then
							-- if we find a buff matching one in our alerted group, we then check its start time against our current one.  if they line up, they're refering to the same buff and we've already alerted it, and we set flag to 1.
							-- if they don't line up, then they're different buffs, so we remove our entry for this buff and leave flag alone.  it will be added again when we alert with updated data.
							if v.begin == buff.begin then
								flag = 1
							else
								alertedSoon[k] = nil
							end
						end
						if v.duration then
							if v.begin <= (Inspect.Time.Frame() - v.duration - 5) then
								alertedSoon[k] = nil
							end
						end
					end
					if flag == 0 then
						table.insert(alertedSoon, buff)
					end
				end
			end
		end
	end
end

--Main loop.
--------------------------------------------------------------------------------------------------------

local function refresh()
	if enabled == 1 then
		local bufflist = Inspect.Buff.List("player")
		if not bufflist then return end 
		
		local buffDeets = Inspect.Buff.Detail("player", bufflist)
		
		-- We run through our buffs and check them against ones we want to track
		for k,v in pairs(buffDeets)do 
			local flag = 0
			for l,b in pairs(listToTrack)do
				if b.name == v.name then
				-- If we find we have a buff applied we want to track then we check to see if we are already tracking it
					if v.duration then
						if trackedBuffs then
						-- we use a tmp table here to avoid changing the size of our loop while iterating on it
							local tmp = trackedBuffs
							for n,buff in pairs(tmp)do
								if buff.name == v.name then
									if topc == 1 then 
										if buff.caster == Inspect.Unit.Lookup("player") then
										-- If we are tracking it, we remove teh old entry and add the new one in order to update the v.duration field
											trackedBuffs[n] = nil
											table.insert(trackedBuffs, v)
										-- We set flag to 1 so we know we found a match outside.	
											flag = 1
										end
									else
									-- If we are tracking it, we remove teh old entry and add the new one in order to update the v.duration field
										trackedBuffs[n] = nil
										table.insert(trackedBuffs, v)
									-- We set flag to 1 so we know we found a match outside.	
										flag = 1
									end
								end
							end
						end
					end
					-- here we check our flag for value.  0 indicates it isn't one we're already tracking and that it should be added to trackedBuffs, 1 indicates we're already tracking it and we should ignore this buff
					if flag == 0 then 
						table.insert(trackedBuffs, v)
					end
			--[[		if buff.remaining then
						print(buff.name .. " " .. buff.remaining)
					end]]
				end
			end
		end

		-- Now that we've established the table trackedBuffs is holding the buffs we care about,  we duplicate it using tmp again and check the durations of our buffs
		local tmp = trackedBuffs
		for k,buff in pairs(tmp) do
			if not buff.duration then 
				trackedBuffs[k] = nil
			end
			--I shouldn't need this check here.  Need to look into it more.
			if buff.duration then
				alertSoon(buff)
				alertDown(buff, k)
			end
		end
	end
end

--Other functions, usually only called once or twice by slash commands. 
-----------------------------------------------------------------------------------------------------------------------------

local function getAbilities()
	local listToRemove = {}
	local abilityList = {}
	local abilityDeets = {}
	local tmp = {}
	local count = 0
	abilityList = Inspect.Ability.List()
	abilityDeets = Inspect.Ability.Detail(abilityList)
	tmp = abilityDeets
	
	for k,v in pairs(tmp) do
		count = count + 1
		if string.sub(v.name, 1, 5) == "Track" then
			abilityDeets[k] = nil
		end
	end
	
	possibleToTrack = abilityDeets
	
	--Eventually, these two will be different once I have a full UI and you can pick and choose which buffs to track more easily.  Not yet though, so they're the same for now
	listToTrack = possibleToTrack	
end

--We now have a comprehensive list of the bard buffs that the player can cast.  Eventually, I'll have an interface or somethign that enables/disables the 
-- tracking of particular buffs, since raid groups could easily have a second bard so you'll want to split buff responsibilities, but I'm not quite there
-- in terms of familiarity with the Rift API.  Even more eventually after that, hopefully I'll be keeping this up to date to track all buffs, but that's 
-- a longer ways off.  I'm only really familiar with bard right now.  Eventually though.

local function on()
	enabled = 1
	getAbilities()
	trackedBuffs = {}
	alertedSoon = {}
	alertedDown = {}
	print("Now watching buffs!")
end

local function off()
	enabled = 0
	notificationDown:SetVisible(false)
	notificationSoon:SetVisible(false)
	print("No longer watching buffs!")
end

local function help()
	print("Type /bb on to enable buff monitoring.\nType /bb off to disable buff monitoring.\n /bb topc to track only buffs you have cast (useful when there is more than 1 of your soul in a group to split buff duties)\n /bb all to track all buffs you're capable of casting, regardless of the current source")
end

local function config(argument)
	if argument == "off" then
		off()
	elseif argument == "on" then
		on()
	elseif argument == "topc" then
		topc = 1
	elseif argument == "all" then
		topc = 0
	elseif argument == "help" then
		help()
	else
		help()
	end
end

table.insert(Event.System.Update.Begin, {refresh, "BBuff", "refresh"})
table.insert(Command.Slash.Register("bb"), {config, "BBuff", "config"})
